/*
 * Copyright 2010-2011 Ning, Inc.
 *
 * Ning licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package com.ning.billing.util.config.catalog;

import java.net.URI;
import java.util.ArrayList;

import org.slf4j.Logger;

public class ValidationErrors extends ArrayList<ValidationError> {
    private static final long serialVersionUID = 1L;

    public void add(final String description, final URI catalogURI,
                    final Class<?> objectType, final String objectName) {
        add(new ValidationError(description, catalogURI, objectType, objectName));

    }

    public void log(final Logger log) {
        for (final ValidationError error : this) {
            error.log(log);
        }
    }

    public String toString() {
        final StringBuilder builder = new StringBuilder();
        for (final ValidationError error : this) {
            builder.append(error.toString());
        }
        return builder.toString();
    }

}
